<?php
//////////////////////////////////////////CONTROLLER.PHP////////////////////////////////////////////
	require_once 'helpers/blti.php';
	require_once 'helpers/meekrodb2.2.class.php';
	DB::$user = '#####';
	DB::$password = '#####';
	DB::$dbName = '#####';

	session_start();
	$_SESSION['courseID'] = $_POST['custom_canvas_course_id'];
	$_SESSION['userID'] = $_POST['custom_canvas_user_id'];
	$_SESSION['domain'] = $_POST['custom_canvas_api_domain'];

	//Check to see if the lti handshake passes (happy is the lti secret)
	$context = new BLTI("######", false, false);
	if ( $context->valid ) {
		/* query DB to see if user has token, if yes, go to LTI*/
		$userCheck = DB::query("SELECT uid FROM tokens WHERE uid = " . $_SESSION['userID']);
		if (!$userCheck){
			/*if not, redirect to canvas permission page*/
			header('Location: https://uvu.instructure.com/login/oauth2/auth?client_id=#####&response_type=code&redirect_uri=https://##########################/php/helpers/oauth2response.php');
		}
		elseif($_POST["roles"]=="Learner"){
			header('Location: https://######################/php/views/studentView.php');	
		}
		elseif(strpos($_POST["roles"], 'Instructor') !== FALSE){
			header('Location: https://###################/php/views/instructorView.php');	
		}
	}
	else {
		echo('There is a problem, tell Dr. Chapman');
	}
?>

/* XML for installing lti tool in LMS
<?xml version="1.0" encoding="UTF-8"?>
<cartridge_basiclti_link xmlns="http://www.imsglobal.org/xsd/imslticc_v1p0"
    xmlns:blti = "http://www.imsglobal.org/xsd/imsbasiclti_v1p0"
    xmlns:lticm ="http://www.imsglobal.org/xsd/imslticm_v1p0"
    xmlns:lticp ="http://www.imsglobal.org/xsd/imslticp_v1p0"
    xmlns:xsi = "http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation = "http://www.imsglobal.org/xsd/imslticc_v1p0 http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticc_v1p0.xsd
    http://www.imsglobal.org/xsd/imsbasiclti_v1p0 http://www.imsglobal.org/xsd/lti/ltiv1p0/imsbasiclti_v1p0.xsd
    http://www.imsglobal.org/xsd/imslticm_v1p0 http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticm_v1p0.xsd
    http://www.imsglobal.org/xsd/imslticp_v1p0 http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticp_v1p0.xsd">
    <blti:title>lticanvasui</blti:title>
    <blti:description>lticanvasui</blti:description>
    <blti:icon></blti:icon>
    <blti:launch_url>https://##########/php/controller.php</blti:launch_url>
    <blti:extensions platform="canvas.instructure.com">
      <lticm:property name="tool_id">lticanvasui</lticm:property>
      <lticm:property name="privacy_level">public</lticm:property>
      <lticm:options name="course_navigation">
        <lticm:property name="url">https://###################php/controller.php</lticm:property>
        <lticm:property name="text">Dashboard</lticm:property>
        <lticm:property name="visibility">public</lticm:property>
        <lticm:property name="default">enabled</lticm:property>
        <lticm:property name="enabled">true</lticm:property>
      </lticm:options>
    </blti:extensions>
    <cartridge_bundle identifierref="BLTI001_Bundle"/>
    <cartridge_icon identifierref="BLTI001_Icon"/>
</cartridge_basiclti_link>  
*/

<?php
//////////////////////////////////////////oauth2response.php////////////////////////////////////////////

	require_once '../helpers/cryptastic.php';
	require_once '../helpers/meekrodb2.2.class.php';
	DB::$user = '#####';
	DB::$password = '#####';
	DB::$dbName = '#####';
	
	session_start();
	// get code query parameter from POST data
	$clientID = '#####';
	$clientSecret = '#####';
	$opts = array('http' => array( 'method'  => 'POST', ));
	$context  = stream_context_create($opts);
	$url = 'https://uvu.instructure.com/login/oauth2/token?client_id='.$clientID.'&client_secret='.$clientSecret.'&code='.$_GET['code'];
	$userTokenJSON = file_get_contents($url, false, $context, -1, 40000); //ASK CANVAS,	USING DEVELOPER TOKEN, TO RETURN STUDENT TOKEN
	$userToken = json_decode($userTokenJSON);

	//encrypt token
	$pass = '#####';
	$salt = '#####';
	$cryptastic = new cryptastic;
	$key = $cryptastic->pbkdf2($pass, $salt, 1000, 32);
	$encryptedToken = $cryptastic->encrypt($userToken->access_token, $key);

	//store encrypted token in the database
	$courseID=$_SESSION['courseID'];
	$userID=$_SESSION['userID'];
	DB::insert('tokens', array(
	  'uid' => $userID,
	  'courseid' => $courseID,
	  'encryptedToken' => $encryptedToken
	));
	//update user info cached data
	$saveUserInfoURL = 'https://###########/saveUserInfo.php?courseID=$courseID';
	exec( $saveUserInfoURL . " > /dev/null &");

	/*  redirect to main tool page */
	header('Location: https://################/views/studentView.php');
?>

<?php
//////////////////////////////////////////canvasAPI.php////////////////////////////////////////////
/* sample call:
	$submissionInfo = get_api_data("https://$domain/api/v1/courses/$courseID/students/submissions?student_ids[]=$userID&access_token=$token&content=submissions&per_page=5000");
*/


	require_once '../helpers/cryptastic.php';
	require_once '../helpers/meekrodb2.2.class.php';
	DB::$user = '#####';
	DB::$password = '######';
	DB::$dbName = '#######';

	//Set variables
	$courseID=$_SESSION['courseID'] ;
	$userID=$_SESSION['userID'];
	$domain=$_SESSION['domain'];


//************************************ Query Tokens ******************************************************************
	//retrieve user token from database
	$encryptedToken = DB::query("SELECT encryptedToken FROM tokens WHERE uid = " . $_SESSION['userID'] );
	
	//decrypt token
	$pass = '#######';
	$salt = '#######';
 	$cryptastic = new cryptastic;
	$key = $cryptastic->pbkdf2($pass, $salt, 1000, 32);
	$token = $cryptastic->decrypt($encryptedToken[0]['encryptedToken'], $key);
	
	//retrieve instructor token from database
	$encryptedTokenInstructor = DB::query("SELECT encryptedToken FROM tokens WHERE uid = 456839" );
	
	//decrypt instructor token
	$pass = '#####';
	$salt = '#####';
 	$cryptastic = new cryptastic;
	$key = $cryptastic->pbkdf2($pass, $salt, 1000, 32);
	$instructorToken = $cryptastic->decrypt($encryptedTokenInstructor[0]['encryptedToken'], $key);
		
	//********************************** REST Queries ****************************************************************************	
	//get data, check header for more pages, repeat if necessary 
	function get_api_data($url){
		global $token;
		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL, $url);
		curl_setopt($ch,CURLOPT_CUSTOMREQUEST, "GET");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_VERBOSE, 1); //Requires to load headers
		curl_setopt($ch, CURLOPT_HEADER, 1);  //Requires to load headers
		$result = curl_exec($ch);
		
		#Parse header information from body response
		$header_size = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
		$header = substr($result, 0, $header_size);
		$body = substr($result, $header_size);
		$data = json_decode($body);
		curl_close($ch);
			
		#Parse Link Information
		$header_info = http_parse_headers($header);
		if(isset($header_info['Link'])){
			$links = explode(',', $header_info['Link']);
			foreach ($links as $value) {
				if (preg_match('/^\s*<(.*?)>;\s*rel="(.*?)"/', $value, $match)) {
					$links[$match[2]] = $match[1];
				}
			}
		}
		#Check for Pagination
		if(isset($links['next'])){
			$next_data = get_api_data($links['next'] . "&access_token=$token");
			$data = array_merge($data,$next_data);
			return $data;
		}else{
			return $data;
		}
	}	
?>